import { Glob } from "bun";
import { loadBindingFile } from "./binding";
import type { AnyResource } from "./playbill-schema";
import { loadResourceFile } from "./resource";

const bindingPath = Bun.argv[2];
const binding = await loadBindingFile(bindingPath);

const fileGlobs = binding.files;
const bindingFileDirname = bindingPath.split("/").slice(0, -1).join("/");

const allFilePaths: string[] = [];

for (const thisGlob of fileGlobs) {
  const glob = new Glob(thisGlob);

  const results = glob.scanSync({
    cwd: bindingFileDirname,
    absolute: true,
    followSymlinks: true,
    onlyFiles: true,
  });

  allFilePaths.push(...results);
}

const loadedResources: AnyResource[] = [];

for (const filepath of allFilePaths) {
  const loaded = await loadResourceFile(filepath);
  loadedResources.push(...loaded);
}

console.log(loadedResources);
